Codeforces1401 B. Ternary Sequence

2024-04-16 00:09

本文主要是介绍Codeforces1401 B. Ternary Sequence,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

You are given two sequences 𝑎1,𝑎2,…,𝑎𝑛 and 𝑏1,𝑏2,…,𝑏𝑛. Each element of both sequences is either 0, 1 or 2. The number of elements 0, 1, 2 in the sequence 𝑎 is 𝑥1, 𝑦1, 𝑧1 respectively, and the number of elements 0, 1, 2 in the sequence 𝑏 is 𝑥2, 𝑦2, 𝑧2 respectively.

You can rearrange the elements in both sequences 𝑎 and 𝑏 however you like. After that, let’s define a sequence 𝑐 as follows:

𝑐𝑖=⎧⎩⎨⎪⎪𝑎𝑖𝑏𝑖0−𝑎𝑖𝑏𝑖if 𝑎𝑖>𝑏𝑖if 𝑎𝑖=𝑏𝑖if 𝑎𝑖<𝑏𝑖
You’d like to make ∑𝑛𝑖=1𝑐𝑖 (the sum of all elements of the sequence 𝑐) as large as possible. What is the maximum possible sum?

Input
The first line contains one integer 𝑡 (1≤𝑡≤104) — the number of test cases.

Each test case consists of two lines. The first line of each test case contains three integers 𝑥1, 𝑦1, 𝑧1 (0≤𝑥1,𝑦1,𝑧1≤108) — the number of 0-s, 1-s and 2-s in the sequence 𝑎.

The second line of each test case also contains three integers 𝑥2, 𝑦2, 𝑧2 (0≤𝑥2,𝑦2,𝑧2≤108; 𝑥1+𝑦1+𝑧1=𝑥2+𝑦2+𝑧2>0) — the number of 0-s, 1-s and 2-s in the sequence 𝑏.

Output
For each test case, print the maximum possible sum of the sequence 𝑐.

Example
inputCopy
3
2 3 2
3 3 1
4 0 1
2 3 0
0 0 1
0 0 1
outputCopy
4
2
0
Note
In the first sample, one of the optimal solutions is:

𝑎={2,0,1,1,0,2,1}
𝑏={1,0,1,0,2,1,0}
𝑐={2,0,0,0,0,2,0}
In the second sample, one of the optimal solutions is:

𝑎={0,2,0,0,0}
𝑏={1,1,0,1,0}
𝑐={0,2,0,0,0}
In the third sample, the only possible solution is:

𝑎={2}
𝑏={2}
𝑐={0}

思路:
贪心的想,就是a数组中的2,肯定是和b数组中的1、2、0依次匹配。
a数组中的1,0肯定是和b数组中的1、0、2。

原因是对2来说只有放1才有贡献,否则剩下不如放2,再其次是0。

#include <cstdio>
#include <cstring>
#include <algorithm>
#include <vector>
#include <queue>using namespace std;typedef long long ll;const int maxn = 1e5 + 7;int mp1[10] = {2,1,0};
int mp2[10] = {1,0,2};int main() {int T;scanf("%d",&T);while(T--) {int a[10],b[10];scanf("%d%d%d",&a[2],&a[1],&a[0]); //2,1,0scanf("%d%d%d",&b[1],&b[0],&b[2]); //1,0,2int ans = 0;for(int i = 0;i <= 2;i++) { //1 2 0if(i == 0) {swap(b[1],b[2]);mp2[1] = 2;mp2[2] = 0;}for(int j = 0;j <= 2;j++) {int num = min(a[i],b[j]);a[i] -= num;b[j] -= num;if(mp1[i] > mp2[j]) {ans += num * mp1[i] * mp2[j];} else if(mp1[i] < mp2[j]) {ans += -num * mp1[i] * mp2[j];} else {ans += 0;}}if(i == 0) {swap(b[1],b[2]);mp2[1] = 0;mp2[2] = 2;}}printf("%d\n",ans);}return 0;
}

这篇关于Codeforces1401 B. Ternary Sequence的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/907301

相关文章

浙大数据结构:02-线性结构4 Pop Sequence

这道题我们采用数组来模拟堆栈和队列。 简单说一下大致思路,我们用栈来存1234.....,队列来存输入的一组数据,栈与队列进行匹配,相同就pop 机翻 1、条件准备 stk是栈,que是队列。 tt指向的是栈中下标,front指向队头,rear指向队尾。 初始化栈顶为0,队头为0,队尾为-1 #include<iostream>using namespace std;#defi

【UVA】1626-Brackets sequence(动态规划)

一道算是比较难理解的动规。 状态转移分2个: (用d[i][j]表示在i~j内最少需要添加几个括号,保持平衡) 1.如果s[i]和s[j]是一对括号,那么d[i][j] = d[i + 1][j - 1] 2.否则的话 d[i][j] = min(d[i][k],[k + 1][j]); 边界是d[i + 1][i] = 0; d[i][i] = 1; 13993644 162

【UVA】10534 - Wavio Sequence(LIS最长上升子序列)

这题一看10000的数据量就知道必须用nlog(n)的时间复杂度。 所以特意去看了最长上升子序列的nlog(n)的算法。 如果有2个位置,该位置上的元素为A[i]和A[j],并且他们满足以下条件: 1.dp[i] = dp[j]    (dp[x]代表以x结尾的最长上升子序列长度) 2.A[i] < A[j] 3.i < j 那么毫无疑问,选择dp[i] 一定优于选择dp[j] 那么

2015年多校联合训练第一场OO’s Sequence(hdu5288)

题意:给定一个长度为n的序列,规定f(l,r)是对于l,r范围内的某个数字a[i],都不能找到一个对应的j使得a[i]%a[j]=0,那么l,r内有多少个i,f(l,r)就是几。问所有f(l,r)的总和是多少。 公式中给出的区间,也就是所有存在的区间。 思路:直接枚举每一个数字,对于这个数字,如果这个数字是合法的i,那么向左能扩展的最大长度是多少,向右能扩展的最大长度是多少,那么i为合法的情况

NYOJ 763 Vawio Sequence

OJ题目 : 戳这里~ 描述 Vawio Sequence is very funny,it is a sequence of integers. It has some interesting properties. ·   Vawio is of odd length i.e. L = 2*n + 1. ·  The first (n+1) integers of  Vawio s

python中使用FormatDataLibsvm转为txt文件后报错illegal multibyte sequence

‘gbk’ codec can’t decode byte 0xff in position 0: illegal multibyte sequence 这个报错是因为编码不对,正确的编码是ANSI编码,txt文件打开后另存为可以看到当前的文本文档编码 但是excel不能直接保存ANSI编码的txt文件 所以不能直接保存为ANSI编码 有两种解决办法 1.新建一个txt文件(新建的txt文件

[LeetCode] 128. Longest Consecutive Sequence

题:https://leetcode.com/problems/longest-consecutive-sequence/description/ 题目 Given an unsorted array of integers, find the length of the longest consecutive elements sequence. Your algorithm should

【ZOJ】3889 Making Sequence【构造】

传送门:【ZOJ】3889 Making Sequence 根据题意构造即可。ZOJ月赛我们抢的第二个FBwww my  code: my~~code: #include <bits/stdc++.h>using namespace std ;typedef unsigned long long ULL ;const int MAXN = 205 ;ULL n , a , b , s ,

CodeForces 487C Prefix Product Sequence

题意: 构造一个1~n的排列  使得n个前缀积%n是一个0~n-1的排列 思路: 首先确定n一定放最后  要不然会有%n会有多个0  这时n-1位置的前缀积为(n-1)! 接着讨论n  n为合数时只有n=4有解  因为如果n为合数一定可以拆成p*q的形式  明显pq|(n-1)! 然后构造ai=(i+1)*inv[i]  因为(i+1)*inv[i] == (j+1)*inv[j]时一

CodeForces 490E Restoring Increasing Sequence

题意: 一个严格递增序列  某些数字的某些位被盖住了  求  恢复后的序列 思路: 贪心  让每个数在大于前一个的基础上尽量的小 先讨论数字长度 len[i]<len[i-1] 一定是NO len[i]>len[i-1] 除了第一位如果是?就填1以外  其他?全填0 len[i]==len[i-1] dfs搜索num[i]格式下大于num[i-1]的最小的数 代码: #include